<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/6/14
 * Time: 16:23
 */

namespace App\Http\Controllers\V1;

use App\Repositories\PostRepositories;
use App\Traits\UserTrait;
use App\Transformers\Post\SuggestTransformer;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Validator;
use Illuminate\Validation\Rule;
use League\Fractal\Manager;
use League\Fractal\Pagination\IlluminatePaginatorAdapter;
use League\Fractal\Resource\Collection;
use League\Fractal\Resource\Item;

class PostController extends Controller
{
    use UserTrait;
    public function __construct(PostRepositories $postRepositories)
    {
        $this->postRepositories = $postRepositories;
    }

    /**
     * 推荐内容列表
     */
    public function suggestPost(Request $request)
    {
        $userInfo = $this->getUserInfo();
        if(empty($userInfo)){
            Log::info('获取用户信息失败');
            return jsonError('获取用户信息失败');
        }
        $param = $request->all();
        $purchaseList = $this->postRepositories->suggestPost($param);
        $fractal = new Manager();
        $resource = new Collection($purchaseList, new SuggestTransformer($userInfo['uid']));
        $resource->setPaginator(new IlluminatePaginatorAdapter($purchaseList));
        $data = $fractal->createData($resource)->toArray();

        if(!(isset($param['current_page']) && $param['current_page'] > 1)){
            $newData = [];
            foreach($data['data'] as $key => $val){
                if($key == 1){
                    $newData[] = ['show_type' => 1];
                }
                $newData[] = $val;
            }
            $data['data'] = $newData;
        }
        return jsonSuccess($data);
    }
}